package com.indigitall.indigitall_flutter_plugin.activities_ind

import android.content.Intent
import android.os.Bundle
import com.indigitall.android.push.HiddenActivity
import com.indigitall.android.push.models.Push
import com.indigitall.indigitall_flutter_plugin.IndigitallFlutterPlugin
import com.indigitall.indigitall_flutter_plugin.utils.FTPreferenceUtils
import org.json.JSONObject

class FTIndigitallHiddenActivity: HiddenActivity() {
    override fun onCreate(bundle: Bundle?) {
        super.onCreate(bundle)
    }

    override fun onHandleIntentAction(intentAction: Intent?) {
        try {
            val context = applicationContext
            if (IndigitallFlutterPlugin.indigitallInterface != null) {
                if (intentAction?.getStringExtra(Push.EXTRA_PUSH) != null) {
                    val json = intentAction.getStringExtra(Push.EXTRA_PUSH)?.let { JSONObject(it) }
                    IndigitallFlutterPlugin.indigitallInterface?.onIndigitallGetPush(
                        context,
                        null,
                        json
                    )
                    val manager = context.packageManager

                    val i = manager.getLaunchIntentForPackage(packageName)
                    i?.addCategory(Intent.CATEGORY_LAUNCHER)
                    context.startActivity(i)
                } else {
                    super.onHandleIntentAction(intentAction)
                }
            } else {
                if (intentAction?.getStringExtra(Push.EXTRA_PUSH) != null) {
                    val json = intentAction.getStringExtra(Push.EXTRA_PUSH)?.let { JSONObject(it) }
                    FTPreferenceUtils.setPushString(context, json.toString())
                }
                super.onHandleIntentAction(intentAction)
            }
        } catch (ex: Exception) {
            ex.printStackTrace()
        }
    }
}