package com.indigitall.indigitall_flutter_plugin.services

import android.content.Context
import com.google.firebase.messaging.RemoteMessage
import com.indigitall.android.push.models.Push
import com.indigitall.android.push.services.FirebaseMessagingService
import com.indigitall.android.push.utils.FirebaseUtils.setPushToken
import com.indigitall.indigitall_flutter_plugin.IndigitallFlutterPlugin
import com.indigitall.indigitall_flutter_plugin.activities_ind.FTPushNotification
import org.json.JSONObject

open class IndigitallFirebaseMessagingService: FirebaseMessagingService() {

    override fun onMessageReceived(remoteMessage: RemoteMessage) {
        super.onMessageReceived(remoteMessage)
        val data = remoteMessage.data as Map<*, *>
        val jsonObject = JSONObject(data)
        IndigitallFlutterPlugin.indigitallInterface?.onIndigitallMessageReceived(this, jsonObject)
    }
    override fun onNewToken(token: String) {
        settingPushToken(this)
        super.onNewToken(token)
    }
    companion object {
        fun settingPushToken(context: Context) {
            setPushToken(context)
        }
    }

    override fun showNotification(context: Context?, push: Push?) {
        if (context != null && push != null) {
            FTPushNotification(push).showNotification(context)
        }
    }

}